"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppModule = void 0;
const admin_authentication_module_1 = require("./modules/admin-authentication/admin-authentication.module");
const admin_authorization_module_1 = require("./modules/admin-authorization/admin-authorization.module");
const admin_user_module_1 = require("./modules/admin-user/admin-user.module");
const common_1 = require("@moonlightjs/common");
const common_2 = require("@nestjs/common");
const app_controller_1 = require("./app.controller");
const app_service_1 = require("./app.service");
const httpContext = require("express-http-context");
let AppModule = class AppModule {
};
AppModule = __decorate([
    (0, common_2.Module)({
        imports: [
            common_1.PrismaModule.forRoot({
                isGlobal: true,
                prismaServiceOptions: {
                    prismaOptions: {
                        log: [
                            {
                                emit: 'event',
                                level: 'query',
                            },
                            {
                                emit: 'stdout',
                                level: 'error',
                            },
                            {
                                emit: 'stdout',
                                level: 'info',
                            },
                            {
                                emit: 'stdout',
                                level: 'warn',
                            },
                        ],
                        errorFormat: 'colorless',
                    },
                    events: {
                        query: common_1.logQueryEvent,
                    },
                    middlewares: [
                        async (params, next) => {
                            console.log('🚀 ---------------------------------------------🚀');
                            console.log('🚀 ~ file: app.module.ts:44 ~ params:', params);
                            console.log('🚀 ---------------------------------------------🚀');
                            const user = httpContext.get('user');
                            const originalUrl = httpContext.get('originalUrl');
                            if (user) {
                                if (params.action === 'create') {
                                    params.args.data.createdById = user.sub;
                                    params.args.data.createdBy = user.username;
                                }
                                if (params.action === 'update') {
                                    params.args.data.updatedById = user.sub;
                                    params.args.data.updatedBy = user.username;
                                }
                            }
                            return next(params);
                        },
                    ],
                },
            }),
            admin_authentication_module_1.AdminAuthenticationModule,
            admin_authorization_module_1.AdminAuthorizationModule,
            admin_user_module_1.AdminUserModule,
        ],
        controllers: [app_controller_1.AppController],
        providers: [app_service_1.AppService],
    })
], AppModule);
exports.AppModule = AppModule;
//# sourceMappingURL=app.module.js.map