"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminPolicyService = void 0;
const admin_policy_dto_1 = require("./dto/admin-policy.dto");
const common_1 = require("@moonlightjs/common");
const common_2 = require("@nestjs/common");
let AdminPolicyService = class AdminPolicyService {
    constructor(prisma) {
        this.prisma = prisma;
    }
    async findOne(params) {
        const adminPolicy = await this.prisma.adminPolicy.findFirst(params);
        return (0, common_1.toDto)(admin_policy_dto_1.AdminPolicyDto, adminPolicy);
    }
    async findAll(params) {
        if (!params.skip) {
            params.skip = 0;
        }
        if (!params.take) {
            params.take = 20;
        }
        const adminPolicys = await this.prisma.adminPolicy.findMany(params);
        return adminPolicys.map((adminPolicy) => (0, common_1.toDto)(admin_policy_dto_1.AdminPolicyDto, adminPolicy));
    }
    async findAllPagination(params) {
        if (!params.skip) {
            params.skip = 0;
        }
        if (!params.take) {
            params.take = 20;
        }
        const [adminPolicys, total] = await Promise.all([
            this.prisma.adminPolicy.findMany(params),
            this.prisma.adminPolicy.count({
                where: params.where,
            }),
        ]);
        return common_1.PagedResultDto.create({
            data: adminPolicys.map((adminPolicy) => (0, common_1.toDto)(admin_policy_dto_1.AdminPolicyDto, adminPolicy)),
            pagination: common_1.Pagination.create({
                take: params.take,
                skip: params.skip,
                total: total,
            }),
        });
    }
    async create(params) {
        const adminPolicy = await this.prisma.adminPolicy.create(params);
        return (0, common_1.toDto)(admin_policy_dto_1.AdminPolicyDto, adminPolicy);
    }
    async update(params) {
        const adminPolicy = await this.prisma.adminPolicy.update(params);
        return (0, common_1.toDto)(admin_policy_dto_1.AdminPolicyDto, adminPolicy);
    }
    async remove(where) {
        const adminPolicy = await this.prisma.adminPolicy.delete({
            where,
        });
        return !!adminPolicy;
    }
    async getAllUserPolicies(userId) {
        const allUserPolicies = [];
        const [userPolicies, userRoles] = await Promise.all([
            await this.prisma.adminPolicy.findMany({
                where: {
                    users: {
                        some: {
                            id: userId,
                        },
                    },
                },
            }),
            this.prisma.adminRole.findMany({
                where: {
                    users: {
                        some: {
                            id: userId,
                        },
                    },
                },
                include: {
                    policies: true,
                },
            }),
        ]);
        allUserPolicies.push(...userPolicies.map((adminPolicy) => (0, common_1.toDto)(admin_policy_dto_1.AdminPolicyDto, adminPolicy)));
        userRoles.forEach((role) => {
            role.policies.forEach((adminPolicy) => {
                allUserPolicies.push((0, common_1.toDto)(admin_policy_dto_1.AdminPolicyDto, adminPolicy));
            });
        });
        return allUserPolicies;
    }
};
AdminPolicyService = __decorate([
    (0, common_2.Injectable)(),
    __metadata("design:paramtypes", [common_1.PrismaService])
], AdminPolicyService);
exports.AdminPolicyService = AdminPolicyService;
//# sourceMappingURL=admin-policy.service.js.map