"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminUserController = void 0;
const admin_jwt_auth_guard_1 = require("../admin-authentication/guards/admin-jwt-auth.guard");
const admin_user_decorator_1 = require("../admin-authentication/admin-user.decorator");
const dto_1 = require("./dto");
const change_admin_password_input_1 = require("./dto/change-admin-password.input");
const update_admin_user_input_1 = require("./dto/update-admin-user.input");
const common_1 = require("@moonlightjs/common");
const common_2 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const client_1 = require("@prisma/client");
const constants_1 = require("../../constants");
const bcrypt = require("bcrypt");
const admin_user_service_1 = require("./admin-user.service");
const admin_user_dto_1 = require("./dto/admin-user.dto");
const admin_policy_guard_1 = require("../admin-authorization/policy/admin-policy.guard");
const admin_policy_decorator_1 = require("../admin-authorization/policy/admin-policy.decorator");
let AdminUserController = class AdminUserController {
    constructor(adminUserService) {
        this.adminUserService = adminUserService;
    }
    getMe(user, params) {
        return this.adminUserService.findOne(Object.assign({ where: {
                id: user.sub,
            } }, params));
    }
    async updatePassword(user, params) {
        return this.adminUserService.changePassword(user.sub, params);
    }
    async create(createAdminUserInput, params) {
        const salt = await bcrypt.genSalt();
        return this.adminUserService.create(Object.assign(Object.assign({}, params), { data: Object.assign(Object.assign({}, createAdminUserInput), { password: createAdminUserInput.password
                    ? await bcrypt.hash(createAdminUserInput.password, salt)
                    : null }) }));
    }
    findAll(params) {
        return this.adminUserService.findAll(params);
    }
    findAllPagination(params) {
        return this.adminUserService.findAllPagination(params);
    }
    findOne(id, params) {
        params.where = {
            id,
        };
        return this.adminUserService.findOne(params);
    }
    async resetPassword(id) {
        return this.adminUserService.resetPassword(id);
    }
    async update(id, updateAdminUserInput, params) {
        return this.adminUserService.update(Object.assign(Object.assign({}, params), { where: {
                id,
            }, data: Object.assign({}, updateAdminUserInput) }));
    }
    remove(id) {
        return this.adminUserService.remove({
            id,
        });
    }
};
__decorate([
    (0, swagger_1.ApiBearerAuth)(),
    (0, common_1.OpenApiResponse)({
        status: common_2.HttpStatus.OK,
        model: admin_user_dto_1.AdminUserDto,
    }),
    (0, common_1.IgnoreAuthorization)(),
    (0, common_2.Get)('me'),
    __param(0, (0, admin_user_decorator_1.AdminUser)()),
    __param(1, (0, common_2.Query)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", void 0)
], AdminUserController.prototype, "getMe", null);
__decorate([
    (0, swagger_1.ApiBearerAuth)(),
    (0, swagger_1.ApiResponse)({ status: common_2.HttpStatus.OK, type: common_1.SuccessResponseDto }),
    (0, common_1.IgnoreAuthorization)(),
    (0, common_2.HttpCode)(common_2.HttpStatus.OK),
    (0, common_2.Post)('/change-password'),
    __param(0, (0, admin_user_decorator_1.AdminUser)()),
    __param(1, (0, common_2.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, change_admin_password_input_1.ChangeAdminPasswordInput]),
    __metadata("design:returntype", Promise)
], AdminUserController.prototype, "updatePassword", null);
__decorate([
    (0, swagger_1.ApiBearerAuth)(),
    (0, swagger_1.ApiBody)({
        type: dto_1.CreateAdminUserInput,
    }),
    (0, common_1.OpenApiResponse)({
        status: common_2.HttpStatus.CREATED,
        model: admin_user_dto_1.AdminUserDto,
    }),
    (0, admin_policy_decorator_1.AdminCheckPolicies)({
        action: constants_1.Actions.AdminUsers.CreateUser,
        resource: constants_1.Resources.adminUsers({
            userId: '.userId',
        }),
    }),
    (0, common_2.Post)(),
    __param(0, (0, common_2.Body)()),
    __param(1, (0, common_2.Query)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [dto_1.CreateAdminUserInput, Object]),
    __metadata("design:returntype", Promise)
], AdminUserController.prototype, "create", null);
__decorate([
    (0, swagger_1.ApiQuery)({
        type: common_1.FindManyArgs,
    }),
    (0, swagger_1.ApiBearerAuth)(),
    (0, common_1.OpenApiResponse)({
        status: common_2.HttpStatus.OK,
        model: admin_user_dto_1.AdminUserDto,
        isArray: true,
    }),
    (0, admin_policy_decorator_1.AdminCheckPolicies)({
        action: constants_1.Actions.AdminUsers.ReadUser,
        resource: constants_1.Resources.adminUsers({
            userId: '.userId',
        }),
    }),
    (0, common_2.Get)(),
    __param(0, (0, common_2.Query)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], AdminUserController.prototype, "findAll", null);
__decorate([
    (0, swagger_1.ApiQuery)({
        type: common_1.FindManyArgs,
    }),
    (0, swagger_1.ApiBearerAuth)(),
    (0, common_1.OpenApiPaginationResponse)(admin_user_dto_1.AdminUserDto),
    (0, admin_policy_decorator_1.AdminCheckPolicies)({
        action: constants_1.Actions.AdminUsers.ReadUser,
        resource: constants_1.Resources.adminUsers({
            userId: '.userId',
        }),
    }),
    (0, common_2.Get)('/pagination'),
    __param(0, (0, common_2.Query)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], AdminUserController.prototype, "findAllPagination", null);
__decorate([
    (0, swagger_1.ApiQuery)({
        type: common_1.FindOneArgs,
    }),
    (0, swagger_1.ApiBearerAuth)(),
    (0, common_1.OpenApiResponse)({ status: common_2.HttpStatus.OK, model: admin_user_dto_1.AdminUserDto }),
    (0, admin_policy_decorator_1.AdminCheckPolicies)({
        action: constants_1.Actions.AdminUsers.ReadUser,
        resource: constants_1.Resources.adminUsers({
            userId: '.userId',
        }),
    }),
    (0, common_2.Get)(':id'),
    __param(0, (0, common_2.Param)('id')),
    __param(1, (0, common_2.Query)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Object]),
    __metadata("design:returntype", void 0)
], AdminUserController.prototype, "findOne", null);
__decorate([
    (0, swagger_1.ApiBearerAuth)(),
    (0, swagger_1.ApiResponse)({ status: common_2.HttpStatus.OK, type: common_1.SuccessResponseDto }),
    (0, admin_policy_decorator_1.AdminCheckPolicies)({
        action: constants_1.Actions.AdminUsers.ResetPassword,
        resource: constants_1.Resources.adminUsers({
            userId: '.userId',
        }),
    }),
    (0, common_2.Patch)(':id/reset-password'),
    __param(0, (0, common_2.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], AdminUserController.prototype, "resetPassword", null);
__decorate([
    (0, swagger_1.ApiBearerAuth)(),
    (0, common_1.OpenApiResponse)({ status: common_2.HttpStatus.OK, model: admin_user_dto_1.AdminUserDto }),
    (0, admin_policy_decorator_1.AdminCheckPolicies)({
        action: constants_1.Actions.AdminUsers.UpdateUser,
        resource: constants_1.Resources.adminUsers({
            userId: '.userId',
        }),
    }),
    (0, common_2.Patch)(':id'),
    __param(0, (0, common_2.Param)('id')),
    __param(1, (0, common_2.Body)()),
    __param(2, (0, common_2.Query)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, update_admin_user_input_1.UpdateAdminUserInput, Object]),
    __metadata("design:returntype", Promise)
], AdminUserController.prototype, "update", null);
__decorate([
    (0, swagger_1.ApiBearerAuth)(),
    (0, swagger_1.ApiResponse)({ status: common_2.HttpStatus.OK, type: common_1.SuccessResponseDto }),
    (0, admin_policy_decorator_1.AdminCheckPolicies)({
        action: constants_1.Actions.AdminUsers.DeleteUser,
        resource: constants_1.Resources.adminUsers({
            userId: '.userId',
        }),
    }),
    (0, common_2.Delete)(':id'),
    __param(0, (0, common_2.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", void 0)
], AdminUserController.prototype, "remove", null);
AdminUserController = __decorate([
    (0, swagger_1.ApiTags)('admin-user'),
    (0, common_2.Controller)({
        path: 'admin/users',
        version: '1',
    }),
    (0, common_2.UseGuards)(admin_jwt_auth_guard_1.AdminJwtAuthGuard, admin_policy_guard_1.AdminPoliciesGuard),
    __metadata("design:paramtypes", [admin_user_service_1.AdminUserService])
], AdminUserController);
exports.AdminUserController = AdminUserController;
//# sourceMappingURL=admin-user.controller.js.map